<?php 
/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */


/**
 * Classe à utiliser pour créer les produits
 * Par exemple pour une gestion des articles dans un magasin
 * 
 */
class ProductController
{
  
	public static function create($sProductType)
	{
		// Ajoutez une validation des données en entrée

		// création de notre produit, instancie automatiquement la classe adéquate
		$oProduct = ProductFactory::build($sProductType, self::generateRandNumber(5), self::generateRandString(8) );


		// effectuez le traitement nécessaire sur la classe produit créée
		// sauvegarde, affichage...

		return $oProduct;// renvoie le produit
	}


	/**
	 * Création d'une chaine de caractères aléatoire
	 * 
	 * @param  integer $length [description]
	 * @return [type]          [description]
	 */
	public static function generateRandString($length = 29)
	{
	    $characters = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
	    $charactersLength = strlen($characters);
	    $randomString = '';
	    
	    for ($i = 0; $i < $length; $i++)
	    {
	        $randomString .= $characters[rand(0, $charactersLength - 1)];
	    }

	    return $randomString;
	}


	/**
	 * Création d'une chaine de nombre aléatoire
	 * 
	 * @param  integer $length [description]
	 * @return [type]          [description]
	 */
	public static function generateRandNumber($length = 29)
	{
	    $characters = '0123456789';
	    $charactersLength = strlen($characters);
	    $randomString = '';
	    
	    for ($i = 0; $i < $length; $i++)
	    {
	        $randomString .= $characters[rand(0, $charactersLength - 1)];
	    }

	    return $randomString;
	}

}



?>