<?php 
/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */



/**
 * Exemple de classe avec Fabrique
 * 
 * S'occupe de la création des objets (instanciation)
 * en fonction du paramètre d'entrée
 * 
 */
class ProductFactory
{

    /**
     * Méthode static qui s'occupe de l'instanciation de l'objet en fonction du paramètre d'entrée
     * @param  [type] $product_type [description]
     * @param  [type] $nReference          [description]
     * @param  [type] $sModele         [description]
     * @return [type]               [description]
     */
    public static function build($sProductType, $nReference, $sModele)
    {
        $oClassProduct = "Product" . ucwords($sProductType);// détermine la classe à instancier
        
        // si la classe existe
        if( class_exists($oClassProduct) )
        {
            return new $oClassProduct($nReference, $sModele);
        }
        else
        {
            throw new Exception("Produit invalide, création impossible !!!");
        }
    }


}

?>